/*
Bin_Button.h - binary button for use with the edanator

Copyright (C) 2004  Edward S. Arthur (ed.arthur@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INC_BIN_BUTTON_H
#define INC_BIN_BUTTON_H

#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl.H>

#define BIT_NUMBER_HEIGHT	10
#define BIN_BUTTON_WIDTH	12
#define BIN_BUTTON_HEIGHT	12
#define BIN_BUTTON_SPACE	4

class Bin_Hex_Widget;

class Bin_Button : public Fl_Button {
  int x, y;
  int value;
public:
  int endian;
  Fl_Box *bit_box;
  Bin_Button(int x, int y, int width, int height, char *label, int bit_select, int endian);
  int handle(int event);
  int get_value(void);
  void update_bit(void);
  void toggle_bit(void);
  void set_value(int value);
  static void cb_key_press_bin(Fl_Widget *w, void *p);
  const char *get_string(int bit_index);
  static void cb_endianness_swap(Fl_Widget *w, void *p);
};


#endif
