/*
Bin_Hex_Array.h - binary hex array for use with the edanator

Copyright (C) 2004  Edward S. Arthur (ed.arthur@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INC_BIN_HEX_ARRAY_H
#define INC_BIN_HEX_ARRAY_H

#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Group.H>
#include <FL/Fl.H>

//#define BIN_HEX_WIDGETS		16

#define BIN_HEX_ARRAY_HEIGHT	(BIN_HEX_WIDGET_HEIGHT + 5)

#define INPUT_PROMPT            "Enter_value_here"

class Bin_Button;
class Hex_Button;
class Bin_Hex_Widget;

class Bin_Hex_Array : Fl_Group {
public:
  int endian;
  Bin_Hex_Widget **bh;

  Fl_Button *left1, *left4, *right1, *right4;
  Fl_Button *clear, *endianness;

  Fl_Int_Input *input;
  Fl_Output *hex_out;
  Fl_Output *dec_out;

  Bin_Hex_Array(int x, int y, int width, int height, const char *label,
		int endian);
  void show(void);
  static void shift_left_bit_cb(Fl_Widget *w, void *p);
  static void shift_right_bit_cb(Fl_Widget *w, void *p);
  void shift_right_bit(void);
  void shift_left_bit(void);
  static void shift_left_nib_cb(Fl_Widget *w, void *p);
  static void shift_right_nib_cb(Fl_Widget *w, void *p);
  static void clear_cb(Fl_Widget *w, void *p);
  static void input_cb(Fl_Widget *w, void *p);
  static void swap_endianness_cb(Fl_Widget *w, void *p);
  unsigned long long int get_value(void);
  unsigned long long int get_reverse_value(void);
  void set_value(unsigned long long int value);
  void fix_output(void);
  const char *endian_label(void);
};

#endif
