/*
Bin_Hex_Array.h - binary hex widget for use with the edanator

Copyright (C) 2004  Edward S. Arthur (ed.arthur@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INC_BIN_HEX_WIDGET_H
#define INC_BIN_HEX_WIDGET_H

#include <FL/Fl_Group.H>
#include <FL/Fl.H>

#define BIN_HEX_WIDGET_WIDTH	((BIN_BUTTON_WIDTH*4)+(BIN_BUTTON_SPACE*3))
#define BIN_HEX_WIDGET_HEIGHT	(BIT_NUMBER_HEIGHT+BIN_BUTTON_HEIGHT+BIN_HEX_WIDGET_WIDTH)

class Bin_Button;
class Hex_Button;
class Bin_Hex_Array;


class Bin_Hex_Widget : Fl_Group {
public:
  Bin_Button *bb[4];
  Hex_Button *hb;

  Bin_Hex_Widget(int x, int y, int width, int height, const char *label,
		 int nibble, int endian);
  void show(void);
  void fix_bits(int call_parent = 0);
  void fix_nibble(int call_parent = 0);
};

#endif
