/*
Hex_Button.h - hex button for use with the edanator

Copyright (C) 2004  Edward S. Arthur (ed.arthur@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INC_HEX_BUTTON_H
#define INC_HEX_BUTTON_H

#include <FL/Fl_Button.H>
#include <FL/Fl.H>

class Bin_Hex_Widget;

class Hex_Button : public Fl_Button {
  int x, y;
  int value;

public:
  Hex_Button(int x, int y, int width, int height, char *label) :
    Fl_Button(x, y, width, height, label) {
    this->x     = x;
    this->y     = y;
    this->value = 0;
    this->labelsize(32);
  }
  int handle(int event);
  int get_value(void);
  void incr_decr_nib(void);
  char *get_nib_str(int idx);
  void set_value(int value);
  void increment(Bin_Hex_Widget *parent);
  void decrement(Bin_Hex_Widget *parent);
};

#endif
