/*
edanator.h - binary/hex graphical calculator

Copyright (C) 2004  Edward S. Arthur (ed.arthur@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define VERSION "edanator V1.03"

#define MAX_BITS 64
#define MAX_NIBS (MAX_BITS/4)



#ifdef WIN32
#define IN_LL_FMT_HEX  "%I64x"
#define IN_LL_FMT_DEC  "%I64u"
#define OUT_LL_FMT_HEX "0x%I64x"
#define OUT_LL_FMT_DEC "%I64u"
#define CASECMP        strnicmp
#else
#define IN_LL_FMT_HEX  "%llX"
#define IN_LL_FMT_DEC  "%llu"
#define OUT_LL_FMT_HEX "0x%llX"
#define OUT_LL_FMT_DEC "%llu"
#define CASECMP        strncasecmp
#endif


#define EDANATOR_LITTLE_ENDIAN	0
#define EDANATOR_BIG_ENDIAN	1



class edanator_opts {
 public:
  int bits;		// number of bits
  int nibs;		// number of nibbles
  int show_x;
  int show_y;
  int show_z;
  int endian;

  edanator_opts(void);
  
  int rows(void);
  int width(void);
  int height(void);
};
